/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 3    MBARC.CPP    12-Aug-94    10:27:42 #    */

/* ************************************************************* *
 *  MBARC.C  -  MetaBGI arc() function                           *
 *  Copyright (c) 1994 Metagraphics Software Corporation         *
 * ************************************************************* */


#include "metabgi.h"


void far _Cdecl arc ( int x, int y,    // center point
                      int stangle,     // start angle
                      int endangle,    // end angle
                      int radius )     // radius
{
   int  radY, radX;

   metabgi.mwArcX = x;                      // save the center point
   metabgi.mwArcY = y;

   // factor in aspect ratio
   radY = (long) radius;
   radX = (long) radius * metabgi.bgiAspectY / metabgi.bgiAspectX;

   metabgi.mwArcRect.Xmin = x - radX;     // compute the bounding rect
   metabgi.mwArcRect.Ymin = y - radY;
   metabgi.mwArcRect.Xmax = x + radX;
   metabgi.mwArcRect.Ymax = y + radY;

   metabgi.mwArcBgnAngle = stangle * 10;    // compute MW arc angles
   metabgi.mwArcArcAngle = ( endangle - stangle ) * 10;

   CheckLineStyle1();  // inline check/set for non-dashed lines (metabgi.h)
   FrameArc ( &metabgi.mwArcRect,           // draw the arc
               metabgi.mwArcBgnAngle,
               metabgi.mwArcArcAngle );
}


/* End of File - MBARC.C */

