/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 2    MBBAR3D.CPP    4-Jan-95    13:14:52 #    */

/* ************************************************************* *
 *  MBBAR3D.C  -  MetaBGI bar3d() function                       *
 *  Copyright (c) 1994 Metagraphics Software Corporation         * 
 * ************************************************************* */


#include "metabgi.h"



void far _Cdecl bar3d ( int X1, int Y1,   // upper left corner
                        int X2, int Y2,   // lower right corner
                        int depth,        // bar depth
                        int topflag )     // draw(!0), noDraw(=0) top
{
   rect  R;

   // setup the bar rectangle
   if ( X1 <= X2 )
      { R.Xmin = X1; R.Xmax = X2; }

   else // if ( X1 > X2 )
      { R.Xmin = X2; R.Xmax = X1; }

   if ( Y1 <= Y2 )
      { R.Ymin = Y1; R.Ymax = Y2; }

   else // if ( Y1 > Y2 )
      { R.Ymin = Y2; R.Ymax = Y1; }


   // fill the bar
   RasterOp( 0 );
   PenColor ( metabgi.fillsettings.color );
   FillRect ( &R, metabgi.mwFillPattern );

   // draw the bar outline
   PenDash ( metabgi.mwLineDash );
   PenColor  ( metabgi.mwLineColor );
   MoveTo ( R.Xmax, R.Ymax );
   LineTo ( R.Xmax, R.Ymin );
   LineTo ( R.Xmin, R.Ymin );
   LineTo ( R.Xmin, R.Ymax );
   LineTo ( R.Xmax, R.Ymax );

   if ( depth > 0 )
      {
      // draw the right side of the 3d bar
      LineTo ( R.Xmax+depth, R.Ymax-depth );
      LineTo ( R.Xmax+depth, R.Ymin-depth );
      LineTo (       R.Xmax,       R.Ymin );

      // if topflag is non-zero
      if ( topflag )
         { // draw the top of the 3d bar
         MoveTo (       R.Xmin,       R.Ymin );
         LineTo ( R.Xmin+depth, R.Ymin-depth );
         LineTo ( R.Xmax+depth, R.Ymin-depth );
         } // if ( topflag...

      } // if ( depth...

   metabgi.mwFlags = 0;  // reset line/fill flag settings   

} // bar3d()


/* End of File - MBBAR3D.C */

