/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 2    MBGETMON.CPP    23-Feb-94    16:45:06 #    */

/* ************************************************************* *
 *  MBGETMON.C  -  MetaBGI getmodename() function                *
 *  Copyright (c) 1994 Metagraphics Software Corporation         *
 * ************************************************************* */


#include "metabgi.h"

#define maxCGA_ID  4
static char CGA_Name[maxCGA_ID+1][12] = {
   {"320x200 C0"},{"320x200 C1"},{"320x200 C2"},
   {"320x200 C3"},{"640x200 HI"} };

#define maxMCGA_ID  5
static char MCGA_Name[maxMCGA_ID+1][12] = {
   {"320x200 C0"},{"320x200 C1"}, {"320x200 C2"},
   {"320x200 C3"},{"640x200 MED"},{"640x480 HI"} };

#define maxEGA_ID  1
static char EGA_Name[maxEGA_ID+1][12] = {
   {"640x200 LO"},{"640x350 HI"} };

#define maxEGA64_ID  1
static char EGA64_Name[maxEGA64_ID+1][12] = {
   {"640x200 LO"},{"640x350 HI"} };

#define maxEGAMONO_ID  3
static char EGAMONO_Name[maxEGAMONO_ID+1][10] = {
   {"640x350"},{"640x350"},{"640x350"},{"640x350"} };

#define maxHERC_ID  0
static char HERC_Name[maxHERC_ID+1][8] = { {"720x348"} };

#define maxATT400_ID  5
static char ATT400_Name[maxATT400_ID+1][12] = {
   {"320x200 C0"},{"320x200 C1"}, {"320x200 C2"},
   {"320x200 C3"},{"640x200 MED"},{"640x400 HI"} };

#define maxVGA_ID  2
static char VGA_Name[maxVGA_ID+1][8] = {
   {"640x200"},{"640x350"},{"640x480"} };

#define maxPC3270_ID  0
static char PC3270_Name[maxPC3270_ID+1][8] = { {"720x350"} };

#define maxIBM8514_ID  1
static char IBM8514_Name[maxIBM8514_ID+1][10] = { {"640x480"},{"1024x768"} };

#define maxMETA_ID 4
static char META_Name[maxMETA_ID+1][10] = 
{ {"640x350"},{"640x480"},{"800x600"},{"1024x768"},{"1280x1024"} };


static char badDriver[] = "BADDRIVER";
static char badMode[]   = "BADMODE";


char * far _Cdecl getmodename ( int mode_number )
{
   if ( ( metabgi.bgiDriverID <= 0 ) ||   // check for bad driver ID number
        ( metabgi.bgiDriverID > 44 ) )
      return (char far *)badDriver;

	if ( mode_number < 0 ) 						// check for bad mode number (<0)
      return (char far *)badMode;


   switch ( metabgi.bgiDriverID )
      {
      case 1:  // CGA
         if ( mode_number > maxCGA_ID )
            return (char far *)badMode;
         else
            return (char far *)CGA_Name[mode_number];

      case 2:  // MCGA
         if ( mode_number > maxMCGA_ID )
            return (char far *)badMode;
         else
            return (char far *)MCGA_Name[mode_number];

      case 3:  // EGA
         if ( mode_number > maxEGA_ID )
            return (char far *)badMode;
         else
            return (char far *)EGA_Name[mode_number];

      case 4:  // EGA64
         if ( mode_number > maxEGA64_ID )
            return (char far *)badMode;
         else
            return (char far *)EGA64_Name[mode_number];

      case 5:  // EGAMONO
         if ( mode_number > maxEGAMONO_ID )
            return (char far *)badMode;
         else
            return (char far *)EGAMONO_Name[mode_number];

      case 6:  // IBM8514
         if ( mode_number > maxIBM8514_ID )
            return (char far *)badMode;
         else
            return (char far *)IBM8514_Name[mode_number];

      case 7:  // HERC
         if ( mode_number > maxHERC_ID )
            return (char far *)badMode;
         else
            return (char far *)HERC_Name[mode_number];

      case 8:  // ATT400
         if ( mode_number > maxATT400_ID )
            return (char far *)badMode;
         else
            return (char far *)ATT400_Name[mode_number];

      case 9:  // VGA
         if ( mode_number > maxVGA_ID )
            return (char far *)badMode;
         else
            return (char far *)VGA_Name[mode_number];

      case 10:  // MCGA
         if ( mode_number > maxPC3270_ID )
            return (char far *)badMode;
         else
            return (char far *)PC3270_Name[mode_number];

      default:
         if ( mode_number > maxMETA_ID )
            return (char far *)badMode;
         else
            return (char far *)META_Name[mode_number];
         
      }
}
                                      
/* End of File - MBGETMON.C */

