/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 2    MBGRAPHD.CPP    28-Feb-94    11:20:20 #    */

/* ************************************************************* *
 *  MBGRAPHD.C  -  MetaBGI graphdefaults() function              *
 *  Copyright (c) 1994 Metagraphics Software Corporation         *
 * ************************************************************* */


#include "metabgi.h"


void far _Cdecl graphdefaults ( void )
{

   static dashRcd bgiDash[6];             // bgi-defined line styles
   static Byte    dash1Cnts[2] = {2,2};
   static Byte    dash2Cnts[6] = {0,3,4,3,6,0};
   static Byte    dash3Cnts[4] = {0,3,5,0};
   static Byte    dash4Cnts[2] = {1,5};   // wide line versions
   static Byte    dash5Cnts[6] = {0,6,1,6,3,0};
   static Byte    dash6Cnts[4] = {0,6,2,0};


   // clearing flags will cause fill and line settings to re-init
   metabgi.mwFlags      = 0;         // misc flags

   metabgi.bgiErrCode   =  0;        // successful driver load

   metabgi.mwFillColor   = 15;      // set default fill color
   metabgi.mwFillPattern =  1;      // set default fill pattern
   metabgi.fillsettings.pattern = SOLID_FILL;
   metabgi.fillsettings.color = 15;

   metabgi.mwLineColor   = 15;      // set default line color
   metabgi.mwLineDash    =  0;      // set default line dash
   metabgi.mwLineThick   =  1;      // set default line thickness
   PenDash ( 0 );
   PenSize ( 0, 0 );
   metabgi.linesettings.linestyle = SOLID_LINE;
   metabgi.linesettings.thickness = NORM_WIDTH;
   metabgi.linesettings.upattern = 0xFFFF;

   bgiDash[0].dashSize = 2;
   bgiDash[0].dashList = dash1Cnts; 
   DefineDash( 1, &bgiDash[0] );
   bgiDash[1].dashSize = 6;
   bgiDash[1].dashList = dash2Cnts; 
   DefineDash( 2, &bgiDash[1] );
   bgiDash[2].dashSize = 4;
   bgiDash[2].dashList = dash3Cnts; 
   DefineDash( 3, &bgiDash[2] );
   // wide styles
   bgiDash[3].dashSize = 2;
   bgiDash[3].dashList = dash4Cnts; 
   DefineDash( 4, &bgiDash[3] );
   bgiDash[4].dashSize = 6;
   bgiDash[4].dashList = dash5Cnts; 
   DefineDash( 5, &bgiDash[4] );
   bgiDash[5].dashSize = 4;
   bgiDash[5].dashList = dash6Cnts; 
   DefineDash( 6, &bgiDash[5] );

   metabgi.mwWriteMode   = zREPz;   // set default write mode
   metabgi.bgiWriteMode  = COPY_PUT; 
   RasterOp ( zREPz );

   metabgi.bgiAspectY = 10000;      // set default aspect ratio
   metabgi.bgiAspectX = metabgi.bgiBMap->pixResX * (10000 / metabgi.bgiBMap->pixResY);

   metabgi.mwArcX = metabgi.mwArcY; // last arc status
   SetRect ( &metabgi.mwArcRect, 0,0,0,0 ); 
   metabgi.mwArcBgnAngle = metabgi.mwArcArcAngle = 0;


   // init global text settings, load default font
   metabgi.bgiMultX = metabgi.bgiDivX = 1;
   metabgi.bgiMultY = metabgi.bgiDivY = 1;
   metabgi.textsettings.font      = -1;
   settextstyle ( DEFAULT_FONT, HORIZ_DIR, 1 );
   settextjustify ( LEFT_TEXT, TOP_TEXT );

   // init global viewport settings
   metabgi.viewsettings.left     = 0;
   metabgi.viewsettings.right    = metabgi.bgiPort->portRect.Xmax -1;
   metabgi.viewsettings.top      = 0;
   metabgi.viewsettings.bottom   = metabgi.bgiPort->portRect.Ymax -1;
   metabgi.viewsettings.clip     = 1;

   MoveTo (0,0);

   setallpalette( getdefaultpalette() );




}


/* End of File - MBGRAPHD.C */

