/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 5    MBINITGR.CPP    23-May-94    10:57:36 #    */

/* ************************************************************* *
 *  MBINITGR.C  -  MetaBGI initgraph() function                  *
 *  Copyright (c) 1994 Metagraphics Software Corporation         * 
 * ************************************************************* */


#define _GLOBAL_METABGI  // declare static globals in metabgi.h
#include "metabgi.h"

int initbgi = 0;

// include extended driver/mode defines
//#include "graphicx.h"

#define MAXDRIVER 45
#define MAXMODE 6

// MetaWINDOW graphics card/mode matches to BGI ( 0 = no match)
short int   _mw_card[MAXDRIVER][MAXMODE] = {
  { 0 },
  { EGA320x200, EGA320x200, EGA320x200, EGA320x200, CGA640x200, 0 },
  { EGA320x200, EGA320x200, EGA320x200, EGA320x200, CGA640x200, VGA640x4802 },
  { EGA640x200, EGA640x350, 0, 0, 0, 0 },
  { EGA640x200, EGA640x350, 0, 0, 0, 0 },
  { EGAMono, EGAMono, 0, 0, 0, 0 },
  { 0, V8514A1024x768x8I, 0, 0, 0, 0 },
  { HER720x348, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, ATT640x400 },
  { VGA640x200, VGA640x350, VGA640x480, 0, 0, 0 },
  { TTS720x350, 0, 0, 0, 0, 0 },

   // beyond this is beyond normal bgi support
/* VGA 256 color */
   { VGA320x200X, 0,0,0,0,0 },
/*  ATT DEB */
   { 0,0,0,0,DEB640x200, DEB640x400 },  
/*  Toshiba 3100 */
   { 0, TOS640x400, 0,0,0,0 },

/* these are generic super vga selections that we query to find */
   { 0, 0,   800, 1024, 1280,0 }, // 16 color   
   { 0, 640, 800, 1024, 1280,0 }, // 256 color  
   { 0, 640, 800, 1024, 1280,0 }, // 32767 color  
   { 0, 640, 800, 1024, 1280,0 }, // 65535 color  

/* specific super vga selections follow */

/* VESA */
   { 0, 0,            VESA800x600, VESA1024x768, 0,0 }, 
   { 0, VESA640x480X, VESA800x600X, VESA1024x768X, VESA1280x1024X,0 },   
   { 0, VESA640x480Y, VESA800x600Y, VESA1024x768Y, VESA1280x1024Y,0 },   
   { 0, VESA640x480YY, VESA800x600YY, VESA1024x768YY, VESA1280x1024YY,0 },  
   { 0,0,0,0,0,0 }, // reserved for VESA640x480Z, VESA800x600Z     
/* ATI */
   { 0, 0, ATI800x600, ATI1024x768, 0,0 },   
   { 0, ATI640x480X, ATI800x600X, ATI1024x768X, 0, 0, },
   { 0, ATI640x480Y, 0,0,0,0 },   
/*  COMPAQ  */      
   { 0, CPQ640x480X,  CPQ800x600,  CPQ1024x768X, 0, ATT640x400 },  
/*  Tseng 3000, Orchid Designer,  STB Extra/EM, Quadram VGA Spectra  */
   { 0, 0, STB800x600, STB1024x768, 0,0 },
   { STB640x350X, STB640x480X, 0,0,0,0 },
/* Tseng Labs 4000 */
   { 0, 0, TS4800x600, TS41024x768, 0, 0, },
   { TS4640x350X, TS4640x480X, TS4800x600X, TS41024x768X, 0, 0 },   
   { 0, TS4640x480Y, TS4800x600Y, 0, 0, 0 }, 
/*  GENOA  */
   { GEN640x350X, GEN640x480X, GEN800x600V, GEN1024x768, 0, 0 },
   { 0,           GEN6640x480X, GEN800x600V, GEN61024x768, 0, 0 },      
/*  Oak OTI-067 chipset  */
   { 0, OAK640x480X, OAK800x600, OAK1024x768, 0, 0, }, 
/*  Paradise  */
   { 0, PAR640x480, PAR800x600, PAR1024x768, 0,0 },
   { 0, PAR640x480X, 0,0,0,0 },   
/*  TECMAR VGA/AD */
   { TEC640x350X, TEC640x480X, TEC800x600, TEC1024x768, 0,0 },
/*  Trident Imapact  */
   { 0, 0, TRI800x600, TRI1024x768, 0, 0 },
   { 0, TRI640x480X, TRI800x600X, TRI1024x768X, 0,0 }, 
/*  Video 7 */
   { 0, V7640x480X, V7800x600, V71024x768, 0,0 },  
   { 0, V72640x480X, V72800x600X, V721024x768X, 0,0, }, 

/* S3 */
	{ 0, S3I640x480X, S3I800x600X, S3I1024x768X, 0,0 },
/* ATI Graphics Ultra Pro */
   { 0, ATIUP640x480X, ATIUP800x600X, ATIUP1024x768X, ATIUP1280x1024X, 0 },

   { -1, -1, -1, -1, -1, -1 }

};



void far _Cdecl initgraph ( int far *gdriver, // driver to load (0=auto)
                            int far *gmode,   // graphics mode
                     const char far *pathto ) // path to driver
{
   int   err, i;

   // already inited once ?
   if( initbgi ) {
      *gdriver = metabgi.bgiErrCode = grNoInitGraph; 
      return;
   }
   
   // set search path to user path if non null
   if( pathto )
      MetaPath( (char far *)pathto );
   else
      MetaPath( "" );

   // if autodetect or generic SVGA, call the bgi detectgraph function first
   if ( *gdriver == DETECT || *gdriver == DETECTX ||
        (*gdriver >= SVGA16 && *gdriver <= SVGA64K) )
      detectgraph( gdriver, gmode );


   //  driver or mode number out of range ?
   if( *gdriver >= MAXDRIVER ||
       *gmode >= MAXMODE ||
       *gdriver < 0 ||
       *gmode < 0 ) {
      metabgi.bgiErrCode = *gdriver = grInvalidDriver; // =-4
      return;

   }

   if( _mw_card[*gdriver][*gmode] == 0 ) {
      //  we don't support it 
      metabgi.bgiErrCode = *gdriver = grInvalidDriver; // =-4
      return;
   }

   err = InitGraphics ( _mw_card[*gdriver][*gmode] );
   if( err ) {

      //  we can't init it
      switch( err ) {
         case -3:  metabgi.bgiErrCode = grNoLoadMem; break;
         case -5:  metabgi.bgiErrCode = grNotDetected; break;
         case -6:  metabgi.bgiErrCode = grFileNotFound; break;
         default:  metabgi.bgiErrCode = grNoInitGraph; 
       }
      *gdriver = metabgi.bgiErrCode; 
      return;
   }

   // Display init successful, initialize local variables
   metabgi.bgiDriverID   = *gdriver;				// save the driver number ID
   metabgi.bgiModeID     = *gmode;				   // save the mode number ID
   GetPort ( &metabgi.bgiPort );                // get the port pointer
   metabgi.bgiBMap  = metabgi.bgiPort->portMap; // get bitmap pointer
   metabgi.defFont = metabgi.bgiPort->txFont;
   metabgi.bgiPoolSize = 2048;

   // init user installed font names to null 
   for( i = 0; i < maxUserFont; i++ ) 
      metabgi.userfnt[i][0] = '\0';

   graphdefaults();

   SetDisplay ( GrafPg0 );

   initbgi = 1;

}  // initgraph()



/* device data type */
typedef struct   _device
{  int    num;          /* InitGraphics mode number */
   int    hres;         /* horizontal resolution    */
   int    vres;         /* vertical resolution      */
   long   colors;       /* maxium number of colors  */
   int    id;           /* id number                */
} device;

/* device ID codes */
#define s8514  0
#define sS3    1
#define sHerc  2
#define sCGA   3
#define sEGA   4
#define sVGA   5
#define sSVGA  6
#define sVESA  7
#define sMISC  8

/* output device table */ 
device o_dev[] = {

/* =============== check for accelerated cards first ============== */
 
/*  IBM 8514  */ 
   {  V8514A1024x768x8I,1024, 768,  256,  s8514},
/* S3  =  HP Ultra VGA, Diamond Stealth, Orchid Fahrenheit, and others */
	{ S3I640x480X,       640,  480,  256,  sS3}, 
	{ S3I800x600X,       800,  600,  256,  sS3}, 
	{ S3I1024x768X,      1024, 768,  256,  sS3}, 
/* ATI Graphics Ultra Pro */
   { ATIUP640x480X,     640,  480,  256,  s8514}, 
   { ATIUP800x600X,     800,  600,  256,  s8514}, 
   { ATIUP1024x768X,    1024, 768,  256,  s8514}, 
   { ATIUP1280x1024X,   1280, 1024, 256,  s8514}, 

/* =============== check for standard modes ============== */

/*  HERCULES  */              
   { HER720x348,        720,  348,  2,    sHerc},
/*  CGA  */
   { CGA640x200,        640,  200,  2,    sCGA}, 
/*  EGA  */                           
   { EGA320x200,        320,  200,  16,   sEGA}, 
   { EGA640x200,        640,  200,  16,   sEGA}, 
   { EGA640x350,        640,  350,  16,   sEGA}, 
   { EGAMono,           640,  350,  2,    sEGA}, 
   { EGA640x3502,       640,  350,  2,    sEGA}, 
/*  VGA  */                                   
   { VGA320x200,        320,  200,  16,   sVGA}, 
   { VGA640x200,        640,  200,  16,   sVGA}, 
   { VGA640x350,        640,  350,  16,   sVGA}, 
   { VGA640x480,        640,  480,  16,   sVGA}, 
   { VGA640x4802,       640,  480,  2,    sVGA}, 
   { VGA320x200X,       320,  200,  256,  sVGA}, 

/* =============== check for vendor specific modes ============== */

/* ATI */
   { ATI800x600,        800,  600,  16,   sSVGA }, /* Wonder */                
   { ATI1024x768,       1024, 768,  16,   sSVGA }, /* Wonder+ */
   { ATI640x480X,       640,  480,  256,  sSVGA }, /* Wonder */
   { ATI800x600X,       800,  600,  256,  sSVGA }, /* Wonder XL */
   { ATI1024x768X,      1024, 768,  256,  sSVGA }, /* Wonder XL */
   { ATI640x480Y,       640,  480,  32767,sSVGA }, /* Wonder XL */
/*  ATT  */
   { DEB640x200,        640,  200,  16,   sMISC  },    
   { DEB640x400,        640,  400,  16,   sMISC  },   
/*  COMPAQ  */                                       
   { ATT640x400,        640,  400,  2,    sMISC }, /* Plasma */
   { CPQ800x600,        800,  600,  16,   sSVGA }, /* Adv. VGA */  
   { CPQ640x480X,       640,  480,  256,  sSVGA }, /* Adv. VGA */  
   { CPQ1024x768X,      1024, 768,  256,  sSVGA }, /* QVision */ 
/* Tseng Labs 4000 */
/* Diamond Speedstar, Orchid Pro Designer II, STB VGA EM-16, and others */
   { TS4800x600,        800,  600,  16,   sSVGA }, 
   { TS41024x768,       1024, 768,  16,   sSVGA },    
   { TS4640x350X,       640,  350,  256,  sSVGA },    
   { TS4640x480X,       640,  480,  256,  sSVGA },    
   { TS4800x600X,       800,  600,  256,  sSVGA },    
   { TS41024x768X,      1024, 768,  256,  sSVGA },     
   { TS4640x480Y,       640,  480,  32767,sSVGA },      
   { TS4800x600Y,       800,  600,  32767,sSVGA },      
/*  EVEREX EVGA EV-673 */
   { EVX800x600,        800,  600,  16,   sSVGA }, 
/*  GENOA  */
   { GEN640x480,        640,  480,  16,   sSVGA}, /* EGA 4880 */
   { GEN800x600,        800,  600,  16,   sSVGA}, /* EGA 4880 */
	{ GEN800x600V,       800,  600,  16,   sSVGA}, /* VGA 5/6000 */ 
   { GEN1024x768,       1024, 768,  16,   sSVGA}, /* VGA 5000 */
   { GEN640x350X,       640,  350,  256,  sSVGA}, /* VGA 5000 */
   { GEN640x480X,       640,  480,  256,  sSVGA}, /* VGA 5000 */
   { GEN61024x768,      1024, 768,  16,   sSVGA}, /* VGA 6000 */
   { GEN6640x480X,      640,  480,  256,  sSVGA}, /* VGA 6000 */ 
/*  Oak OTI-067 chipset  */
   { OAK800x600,        800,  600,  16,   sSVGA },    
   { OAK1024x768,       1024, 768,  16,   sSVGA },     
   { OAK640x480X,       640,  480,  256,  sSVGA }, 
/*  Orchid Designer,  STB Extra/EM, Quadram VGA Spectra  */
   { STB800x600,        800,  600,  16,   sSVGA }, 
   { STB1024x768,       1024, 768,  16,   sSVGA },  
   { STB640x350X,       640,  350,  256,  sSVGA },  
   { STB640x480X,       640,  480,  256,  sSVGA }, 
/*  Paradise  */
   { PAR640x480,        640,  480,  16,   sSVGA },  
   { PAR800x600,        800,  600,  16,   sSVGA },  
   { PAR1024x768,       1024, 768,  16,   sSVGA },  
   { PAR640x480X,       640,  480,  256,  sSVGA },  
/*  TECMAR VGA/AD */
   { TEC800x600,        800,  600,  16,   sSVGA },  
   { TEC1024x768,       1024, 768,  16,   sSVGA }, 
   { TEC640x350X,       640,  350,  256,  sSVGA }, 
   { TEC640x480X,       640,  480,  256,  sSVGA }, 
/*  Toshiba 3100 */
   { TOS640x400,        640,  400,  2,    sMISC },               
/*  Trident Imapact  */
   { TRI800x600,        800,  600,  16,   sSVGA }, 
   { TRI1024x768,       1024, 768,  16,   sSVGA },       
   { TRI640x480X,       640,  480,  256,  sSVGA },       
   { TRI800x600X,       800,  600,  256,  sSVGA },       
   { TRI1024x768X,      1024, 768,  256,  sSVGA },       
/*  Video 7 */
   { V7800x600,        800,   600,  16,   sSVGA},
   { V7640x480X,       640,   480,  256,  sSVGA},       
   { V71024x768,       1024,  768,  16,   sSVGA},
   { V71024x768x2,     1024,  768,  2,    sSVGA},
   { V72640x480X,      640,   480,  256,  sSVGA}, /* VRAM II */
   { V72800x600X,      800,   600,  256,  sSVGA}, /* VRAM II */
   { V721024x768X,     1024,  768,  256,  sSVGA}, /* VRAM II */

/* =============== check for VESA standard modes ============== */

/*  VESA super VGA */
   { VESA800x600,       800,  600,  16,   sVESA}, 
   { VESA1024x768,      1024, 768,  16,   sVESA}, 
   { VESA640x480X,      640,  480,  256,  sVESA}, 
   { VESA800x600X,      800,  600,  256,  sVESA}, 
   { VESA1024x768X,     1024, 768,  256,  sVESA}, 
   { VESA1280x1024X,    1280, 1024, 256,  sVESA}, 
   { VESA640x480Y,      640,  480,  32767,sVESA}, 
   { VESA640x480YY,     640,  480,  65535L,sVESA}, 
   { VESA800x600Y,      800,  600,  32767 ,sVESA}, 
   { VESA800x600YY,     800,  600,  65535L,sVESA}, 
   { VESA1024x768Y,     1024, 768,  32767 ,sVESA}, 
   { VESA1024x768YY,    1024, 768,  65535L,sVESA}, 
   { VESA1280x1024Y,    1280, 1024, 32767 ,sVESA}, 
   { VESA1280x1024YY,   1280, 1024, 65535L,sVESA},
//   { VESA640x480Z,      640,  480,  16777216L,sVESA}, 
//   { VESA800x600Z,      800,  600,  16777216L,sVESA}, 
                                 
   { 0, 0, 0, 0, sMISC }
};
/*  The last entry should always be 0,  no device located   */


void far _Cdecl detectgraph ( int far *gdriver, int far *gmode )
{

   long svga;
   int i, hicolor, accel, medcolor;
   device best;
   dirRec   drvDir;


   // if generic supervga, limit any search to type of vga
   switch( *gdriver ) {
      case SVGA16:  svga = 16;       break;     
      case SVGA256: svga = 256;      break;      
      case SVGA32K: svga = 32767;    break;      
      case SVGA64K: svga = 16777216; break;      
      default: svga = 0;        break;
   };

   // if not autodetect or generic SVGA, just check specific card
   if ( *gdriver != DETECT && *gdriver != DETECTX && !svga ) {

      if( _mw_card[*gdriver][*gmode] != 0 ) {

         if( QueryGraphics ( _mw_card[*gdriver][*gmode] <= 0 ) )
            return;
      }

      // not detected or not supported
      metabgi.bgiErrCode = *gdriver = grNotDetected; // -2
      return;
   }

   // auto detect


   if( (*gdriver == DETECTX) || svga ) {

      /* do they have additional  drivers ? */
      medcolor = ResrcQuery ( "METWND08.DLL", &drvDir, 1);
      hicolor = ResrcQuery ( "METWND09.DLL", &drvDir, 1);
      accel   = ResrcQuery ( "METWND07.DLL", &drvDir, 1);
   }
   else 
      medcolor = hicolor = accel = 0;

   best.num = best.hres = best.vres = 0;
   best.colors = 0L;

   /*  for each device in the table  */
   for( i = 0; o_dev[i].num; i++ ) {


      /* is device beyond our search limits ? */
      if( *gdriver == DETECT ) {

         if( o_dev[i].id > sVGA )
            continue;      /* yep */
      }

      if( svga ) {

         if( o_dev[i].id != sSVGA )
            continue;      /* yep */

         if( o_dev[i].colors != svga )
            continue;      /* yep */

         if( o_dev[i].hres != *gmode ) 
            continue;      /* yep */

      }



      /* is extra driver present ? */

      if( o_dev[i].colors > 256 )
         if( !hicolor )
            continue;      /* nope */

      if( o_dev[i].id == s8514 ||  o_dev[i].id == sS3 )
         if( !accel )
            continue;      /* nope */

      if( o_dev[i].colors > 16 )
         if( !medcolor )
            continue;      /* nope */



      /* is card present ? */
      if( QueryGraphics( o_dev[i].num ) )
         continue;      /* nope */



   /*
   re-arrange the order of these tests if you wish the weightings other than
   colors - vertical - horizontal
   */

      /* does it have the best color resolution so far ? */
      if( o_dev[i].colors < best.colors  )
         continue;      /* nope */
      if( o_dev[i].colors > best.colors  )
         best = o_dev[i];  

      /* does it have the best vertical resolution so far ? */
      if( o_dev[i].vres < best.vres  ) 
         continue;      /* nope */
      if( o_dev[i].vres > best.vres  ) 
         best = o_dev[i];  

      /* does it have the best horizontal resolution so far ? */
      if( o_dev[i].hres < best.hres ) 
         continue;      /* nope */
      if( o_dev[i].hres > best.hres ) 
         best = o_dev[i];  

   }

   // best.num = metawindow num of best adapter
   if( best.num == 0 ) {
      // nothing detected
      metabgi.bgiErrCode = *gdriver = grNotDetected; // -2
      return;
   }

   // find bgi driver/mode combination equivalent
   for( *gdriver = 1; _mw_card[*gdriver][0] >= 0; (*gdriver)++ ) {
      for( *gmode = 0; *gmode < 6; (*gmode)++ ) {
         if( _mw_card[*gdriver][*gmode] == best.num )
            return;
      }
   }

}




/* End of File - MBINITGR.C */

