/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 3    MBPIESLI.CPP    12-Aug-94    10:27:32 #    */

/* ************************************************************* *
 *  MBPIESLI.C  -  MetaBGI pieslice() function                   *
 *  Copyright (c) 1994 Metagraphics Software Corporation         *
 * ************************************************************* */


#include "metabgi.h"


void far _Cdecl pieslice ( int x, int y,   // center point
                           int stangle,    // start angle
                           int endangle,   // end angle
                           int radius )    // radius
{
   point  pt;
   int    radX, radY;

   // factor in aspect ratio
   radY = (long) radius;
   radX = (long) radius * metabgi.bgiAspectY / metabgi.bgiAspectX;

   metabgi.mwArcX = x;                      // save the center point
   metabgi.mwArcY = y;

   metabgi.mwArcRect.Xmin = x - radX;       // compute the bounding rect
   metabgi.mwArcRect.Ymin = y - radY;
   metabgi.mwArcRect.Xmax = x + radX;
   metabgi.mwArcRect.Ymax = y + radY;

   metabgi.mwArcBgnAngle = stangle * 10;    // compute MW arc angles
   metabgi.mwArcArcAngle = ( endangle - stangle ) * 10;

   CheckFillStyle();   // inline check/set for fill (metabgi.h)

   // fill the arc
   FillArc  ( &metabgi.mwArcRect,
               metabgi.mwArcBgnAngle,
               metabgi.mwArcArcAngle,
               metabgi.mwFillPattern );

   CheckLineStyle1();  // inline check/set for non-dashed lines (metabgi.h)

   // draw the arc outline
   FrameArc ( &metabgi.mwArcRect,
               metabgi.mwArcBgnAngle,
               metabgi.mwArcArcAngle );

   // get the starting arc coordinate
   OvalPt ( &metabgi.mwArcRect, metabgi.mwArcBgnAngle, &pt );

   // draw the 1st edge of the pie
   MoveTo ( pt.X, pt.Y );
   LineTo ( x, y );

   // get the ending arc coordinate
   OvalPt ( &metabgi.mwArcRect,
             metabgi.mwArcBgnAngle+metabgi.mwArcArcAngle, &pt );

   // draw the 2nd edge of the pie
   LineTo ( pt.X, pt.Y );

}


/* End of File - MBPIESLI.C */

