/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 2    MBPUTIMA.CPP    18-Feb-94    14:27:02 #    */

/* ************************************************************* *
 *  MBPUTIMA.C  -  MetaBGI putimage() function                   *
 *  Copyright (c) 1994 Metagraphics Software Corporation         *
 * ************************************************************* */


#include "metabgi.h"


void far _Cdecl putimage ( int left, int top,       // top,left corner
                           const void far *bitmap,  // pointer to image bits
                           int op )                 // rasterOp
{
   // MetaWINDOW rasterOp matches to BGI
   int  rops[] = { zREPz, zXORz, zORz, zANDz, zNREPz };
   rect imageRect;
   unsigned short int *im;
   int h,w;

   // read height and width from first two words of image buffer
   im = ( unsigned short int *) bitmap;
   w = *im++;
   h = *im++;

   SetRect ( &imageRect, left, top, left+w, top+h );

   RasterOp ( rops[op] );                       // set specified rasterOp
   WriteImage ( &imageRect, (image *) im );     // write the image
   RasterOp ( zREPz );                          // reset default rasterOp
   metabgi.mwFlags &= ~flgLineStyle2;   

} /* putimage() */


/* End of File - MBPUTIMA.C */

