/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 1    MBSECTOR.CPP    11-Feb-94    17:40:44 #    */

/* ************************************************************* *
 *  MBSECTOR.C  -  MetaBGI sector() function                     *
 *  Copyright (c) 1994 Metagraphics Software Corporation         *
 * ************************************************************* */


#include "metabgi.h"


void far _Cdecl sector ( int x, int y,  // center point
                         int stangle,   // start angle
                         int endangle,  // end angle
                         int xradius,   // X radius
                         int yradius )  // Y radius
{
   point  pt;

   metabgi.mwArcX = x;                      // save the center point
   metabgi.mwArcY = y;

   metabgi.mwArcRect.Xmin = x - xradius;    // compute the bounding rect
   metabgi.mwArcRect.Ymin = y - yradius;
   metabgi.mwArcRect.Xmax = x + xradius;
   metabgi.mwArcRect.Ymax = y + yradius;

   metabgi.mwArcBgnAngle = stangle * 10;    // compute MW arc angles
   metabgi.mwArcArcAngle = ( endangle - stangle ) * 10;

   CheckFillStyle();   // inline check/set for fill (metabgi.h)

   // fill the arc
   FillArc  ( &metabgi.mwArcRect,
               metabgi.mwArcBgnAngle,
               metabgi.mwArcArcAngle,
               metabgi.mwFillPattern );

   CheckLineStyle1();  // inline check/set for non-dashed lines (metabgi.h)

   // draw the arc outline
   FrameArc ( &metabgi.mwArcRect,
               metabgi.mwArcBgnAngle,
               metabgi.mwArcArcAngle );

   // get the starting arc coordinate
   OvalPt ( &metabgi.mwArcRect, metabgi.mwArcBgnAngle, &pt );

   // draw the 1st edge of the pie
   MoveTo ( pt.X, pt.Y );
   LineTo ( x, y );

   // get the ending arc coordinate
   OvalPt ( &metabgi.mwArcRect,
             metabgi.mwArcBgnAngle+metabgi.mwArcArcAngle, &pt );

   // draw the 2nd edge of the pie
   LineTo ( pt.X, pt.Y );

}


/* End of File - MBSECTOR.C */

