/*  %kw # %v    %n    %d    %t #  */
/*  Version # 1    MBSETALL.CPP    14-Feb-94    11:38:18 #    */

/* ************************************************************* *
 *  MBSETALL.C  -  MetaBGI setallpalette() function              *
 *  Copyright (c) 1994 Metagraphics Software Corporation         *
 * ************************************************************* */


#include "metabgi.h"


void far _Cdecl setallpalette ( const struct palettetype far *palette )
{
   /* take user buffer of rgbr'g'b' values and set the palette */
   /* a value of -1 means noop for that color index */

   palData mwpalette[256];
   int i, numclrs;

   numclrs = (int)  QueryColors ();

   /* first get current palette */
   ReadPalette ( 0, 0, numclrs, mwpalette );

   /* now convert each user entry to straight RGB */
   for( i = 0; i < palette->size; i++ ) {

      /* ignore -1 settings */
      if( palette->colors[i] == -1 )
         continue;

      mwpalette[i].palRed = mwpalette[i].palGreen = mwpalette[i].palBlue = 0;
      if( palette->colors[i] & 0x04 )
         mwpalette[i].palRed |= 0x8000;
      if( palette->colors[i] & 0x20 )
         mwpalette[i].palRed |= 0x4000;
      if( palette->colors[i] & 0x02 )
         mwpalette[i].palGreen |= 0x8000;
      if( palette->colors[i] & 0x10 )
         mwpalette[i].palGreen |= 0x4000;
      if( palette->colors[i] & 0x01 )
         mwpalette[i].palBlue |= 0x8000;
      if( palette->colors[i] & 0x08 )
         mwpalette[i].palBlue |= 0x4000;

   }

   WritePalette ( 0, 0, numclrs, mwpalette );

}


/* End of File - MBSETALL.C */

