/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 2    MBSETGRM.CPP    18-Feb-94    14:53:16 #    */

/* ************************************************************* *
 *  MBSETGRA.C  -  MetaBGI setgraphmode() function               *
 *  Copyright (c) 1994 Metagraphics Software Corporation         *
 * ************************************************************* */


#include "metabgi.h"

extern short int _mw_card[45][6];

void far _Cdecl setgraphmode ( int mode )
{
   int err;

   // do we have to switch modes ?
   if( mode != metabgi.bgiModeID )  {
   
      if( _mw_card[metabgi.bgiDriverID][mode] == 0 ) {
         //  we don't support it 
         metabgi.bgiErrCode = grInvalidMode; 
         return;
      }

      // close the current bitmap
      CloseBitmap( metabgi.bgiBMap );

      // init a new bitmap
      err = InitBitmap( _mw_card[metabgi.bgiDriverID][mode], metabgi.bgiBMap );

      if( err ) { 
         //  we can't init it
         switch( err ) {
            case -3:  metabgi.bgiErrCode = grNoLoadMem; break;
            case -5:  metabgi.bgiErrCode = grNotDetected; break;
            case -6:  metabgi.bgiErrCode = grFileNotFound; break;
            default:  metabgi.bgiErrCode = grNoInitGraph; 
          }
      }

      metabgi.bgiModeID = mode;

   }

   SetDisplay ( GrafPg0 );
   graphdefaults();    
}



/* End of File - MBSETGRA.C */

