/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 3    METABGI.H    4-Jan-95    13:13:00 #    */

/* ************************************************************* *
 *  METABGI.H  -  MetaBGI Interface Header File                  *
 *  Copyright (c) 1994 Metagraphics Software Corporation         * 
 * ************************************************************* */


#ifndef  _INCLUDE_METABGI
#define  _INCLUDE_METABGI

#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>
#include "graphics.h"
#include "metawndo.h"      /* master MetaWINDOW include file */



#define maxBGIPat 12
#define maxStdFonts 11 
#define maxUserFont 10

struct mwpat {
   patRcd hdr;
   char   data[8];
};

typedef struct _METABGI    // MetaBGI Global Data Structure and Variables
   {
    int        mwFillColor;     // current fill color      ( setfillstyle() /
    int        mwFillPattern;   // current fill pattern      setfillpattern())
    int        mwLineColor;     // current line color      ( setcolor() )
    int        mwLineDash;      // current line dash style ( setlinestyle() )
    int        mwLineThick;     // current line thickness  ( setlinestyle() )
    int        mwWriteMode;     // current MW write mode   ( setwritemode() )
    int        bgiWriteMode;    // current BGI write mode  ( setwritemode() )
    long       bgiAspectX;      // current X aspect ratio setting
    long       bgiAspectY;      // current Y aspect ratio setting
    int        mwArcX;          // last arc center X
    int        mwArcY;          // last arc center Y
    rect       mwArcRect;       // last arc rect
    int        mwArcBgnAngle;   // last arc mw bgnAngle
    int        mwArcArcAngle;   // last arc mw arcAngle
    int        mwFlags;         // current style setting    (see below)
    int        bgiErrCode;      // current error code
    int        bgiDriverID;     // BGI driver ID number (1-43)
    int        bgiModeID;       // BGI mode ID number (1-10)
    int        bgiMultX;        // setusercharsize() settings
    int        bgiDivX;         //      "               "
    int        bgiMultY;        //      "               "
    int        bgiDivY;         //      "               "
    grafPort  *bgiPort;         // pointer to the BGI port record
    grafMap   *bgiBMap;         // pointer to the BGI bitmap record
    fontRcd   *bgiFont;         // pointer to the current font
    fontRcd   *defFont;         // pointer to the metawindow default font
    struct     linesettingstype   linesettings;
    struct     fillsettingstype   fillsettings;
    struct     textsettingstype   textsettings;
    struct     viewporttype       viewsettings;
    struct     mwpat              usrPat;
    int        bgiPoolSize;      // size of pool buffer
    char       userfnt[10][15];  // installuserfont file names
   }  METABGI;


#ifdef    _GLOBAL_METABGI  // - - - - - - - - - - - - - - - - - - - - - - -

METABGI metabgi;           // if _GLOBAL_METABGI is defined (in MBINITGR.C)

#else  //!_GLOBAL_METABGI

extern METABGI metabgi;    // if _GLOBAL_METABGI is not defined

#endif // _GLOBAL_METABGI  // - - - - - - - - - - - - - - - - - - - - - - -


#endif //_INCLUDE_METABGI


                        // mwFlag settings
#define  flgLineStyle1  1   // line style 1 is set (color & thickness)
#define  flgLineStyle2  2   // line style 2 is set (color, dash & thickness)
#define  flgFillStyle   4   // fill style is set



inline void CheckLineStyle1()    // for arcs, circles, ellipses or pie slices
{
   // check to see if line style (color & thickness) is already set
   if ( metabgi.mwFlags != flgLineStyle1 )
      {
      RasterOp ( 0 );
      PenColor ( metabgi.mwLineColor );
      PenPattern ( 1 );
      PenDash ( 0 );
      metabgi.mwFlags = flgLineStyle1;
      }
}



inline void CheckLineStyle2()    // for line, lineto, rectangle & drawpoly
                                 //   that include dash styles.
{
   // check to see if line style (color, dash & thickness) is already set
   if ( metabgi.mwFlags != flgLineStyle2 )
      {
      RasterOp ( metabgi.mwWriteMode );
      PenColor ( metabgi.mwLineColor );
      PenPattern ( 1 );
      PenDash  ( metabgi.mwLineDash );
      metabgi.mwFlags = flgLineStyle2;
      }
}



inline void CheckFillStyle()
{
   // check to see if fill style (color) is already set
   if ( metabgi.mwFlags != flgFillStyle )
      {
      RasterOp ( 0 );
      PenColor ( metabgi.mwFillColor );
      PenPattern ( metabgi.mwFillPattern );
      metabgi.mwFlags = flgFillStyle;
      }
}



/* End of File - METABGI.H */

