#File:  MWBGIDOS.MAK
#Makefile for Building Metagraphics BGI 16-bit DOS real-mode Interface Library

#*****************************************************************************
#*                                                                           *
#*         Copyright (c) 2000  Metagraphics Software Corporation             *
#*                  PO BOX 225 * Woodinville, WA  98072                      *
#*                Phone: 425-844-1110     FAX:425-844-1112                   *
#*                                                                           *
#*    The source code included herein contains proprietary information of    *
#*  Metagraphics Software Corporation.  Use and distribution of this source  *
#*   code is strictly limited to the terms of the Metagraphics Source Code   *
#*                          License Agreement.                               *
#*                                                                           *
#*           DISSEMINATION OF SOURCE CODE INFORMATION, IN ANY FORM,          *
#*               TO UNLICENSED PARTIES IS STRICTLY PROHIBITED.               *
#*                                                                           *
#*****************************************************************************

#destination lib name
LIBNAME = mwbgidos

#uses which MetaWINDOW lib
METLIB  = met_xd1d.lib        #MetaWINDOW library for Borland 16-bit DOS real-mode

#define if compiling for 386 protected mode 
#IS386   = 1
#define if compiling for 16-bit real-mode
IS386   = 0

#lib directory
LIBDIR  = .


# set librarian prefix and suffix to add an obj into the lib
!IF  $(IS386)
LIBPFX = -add
LIBSFX =
LIBLINE = wlib /c /l $(LIBDIR)\$(LIBNAME) @lib.tmp
!ELSE
LIBPFX  =
LIBSFX  = &
LIBLINE = lib $(LIBDIR)\$(LIBNAME) @lib.tmp
!ENDIF

DEPEND  = metabgi.h

OBJ1  = mbarc.obj    mbbar.obj    mbbar3d.obj  mbcircle.obj mbcleard.obj mbclearv.obj
OBJ2  = mbcloseg.obj mbdetect.obj mbdrawpo.obj mbellips.obj mbfillel.obj mbfillpo.obj
OBJ3  = mbfloodf.obj mbgetarc.obj mbgetasp.obj mbgetbkc.obj mbgetcol.obj mbgetdef.obj
OBJ4  = mbgetdri.obj mbgetflp.obj mbgetfls.obj mbgetgra.obj mbgetima.obj mbgetlin.obj
OBJ5  = mbgetmac.obj mbgetmam.obj mbgetmax.obj mbgetmay.obj mbgetmon.obj mbgetmor.obj
OBJ6  = mbgetpal.obj mbgetpas.obj mbgetpix.obj mbgettex.obj mbgetvie.obj mbgetx.obj
OBJ7  = mbgety.obj   mbgraphd.obj mbgraphe.obj mbgraphf.obj mbgraphg.obj mbgraphr.obj
OBJ8  = mbimages.obj mbinitgr.obj mbinstld.obj mbinstlf.obj mbline.obj   mblinere.obj
OBJ9  = mblineto.obj mbmovere.obj mbmoveto.obj mbouttex.obj mbouttxy.obj mbpiesli.obj
OBJ10 = mbputima.obj mbputpix.obj mbrectan.obj mbregisd.obj mbregisf.obj mbrestor.obj
OBJ11 = mbsector.obj mbsetact.obj mbsetall.obj mbsetasp.obj mbsetbkc.obj mbsetcol.obj
OBJ12 = mbsetflp.obj mbsetfls.obj mbsetgrb.obj mbsetgrm.obj mbsetlin.obj mbsetpal.obj
OBJ13 = mbsetrgb.obj mbsettxj.obj mbsettxs.obj mbsetuse.obj mbsetvie.obj mbsetvis.obj
OBJ14 = mbsetwri.obj mbtexthe.obj mbtextwi.obj mballoc.obj

# -------- the library is the primary target --------
$(LIBDIR)\$(LIBNAME).lib: objA objB lib.tmp
   if exist $(LIBDIR)\$(LIBNAME).lib  del $(LIBDIR)\$(LIBNAME).lib
   $(LIBLINE)


# We use these pseudo targets because of makes line length limits
objA: $(OBJ1)  $(OBJ2)  $(OBJ3)  $(OBJ4)  $(OBJ5)  $(OBJ6)  $(OBJ7)
objB: $(OBJ8)  $(OBJ9)  $(OBJ10) $(OBJ11) $(OBJ12) $(OBJ13) $(OBJ14)


# Generate the librarian response file if it
# doesn't exist, or this makefile has been edited
lib.tmp:  METABGI.MAK
    echo $(LIBPFX) $(OBJ1)  $(LIBSFX) > lib.tmp
    echo $(LIBPFX) $(OBJ2)  $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ3)  $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ4)  $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ5)  $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ6)  $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ7)  $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ8)  $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ9)  $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ10) $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ11) $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ12) $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ13) $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(OBJ14) $(LIBSFX) >> lib.tmp
    echo $(LIBPFX) $(METLIB) $(LIBSFX) >> lib.tmp
!IF  "$(LIBSFX)" == "&"    # MS lib needs this
   echo ; >> lib.tmp
!ENDIF

# c modules
mbarc.obj:     mbarc.cpp     $(DEPEND)
mbbar.obj:     mbbar.cpp     $(DEPEND)
mbbar3d.obj:   mbbar3d.cpp   $(DEPEND)
mbcircle.obj:  mbcircle.cpp  $(DEPEND)
mbcleard.obj:  mbcleard.cpp  $(DEPEND)
mbclearv.obj:  mbclearv.cpp  $(DEPEND)
mbcloseg.obj:  mbcloseg.cpp  $(DEPEND)
mbdetect.obj:  mbdetect.cpp  $(DEPEND)
mbdrawpo.obj:  mbdrawpo.cpp  $(DEPEND)
mbellips.obj:  mbellips.cpp  $(DEPEND)
mbfillel.obj:  mbfillel.cpp  $(DEPEND)
mbfillpo.obj:  mbfillpo.cpp  $(DEPEND)
mbfloodf.obj:  mbfloodf.cpp  $(DEPEND)
mbgetarc.obj:  mbgetarc.cpp  $(DEPEND)
mbgetasp.obj:  mbgetasp.cpp  $(DEPEND)
mbgetbkc.obj:  mbgetbkc.cpp  $(DEPEND)
mbgetcol.obj:  mbgetcol.cpp  $(DEPEND)
mbgetdef.obj:  mbgetdef.cpp  $(DEPEND)
mbgetdri.obj:  mbgetdri.cpp  $(DEPEND)
mbgetflp.obj:  mbgetflp.cpp  $(DEPEND)
mbgetfls.obj:  mbgetfls.cpp  $(DEPEND)
mbgetgra.obj:  mbgetgra.cpp  $(DEPEND)
mbgetima.obj:  mbgetima.cpp  $(DEPEND)
mbgetlin.obj:  mbgetlin.cpp  $(DEPEND)
mbgetmac.obj:  mbgetmac.cpp  $(DEPEND)
mbgetmam.obj:  mbgetmam.cpp  $(DEPEND)
mbgetmax.obj:  mbgetmax.cpp  $(DEPEND)
mbgetmay.obj:  mbgetmay.cpp  $(DEPEND)
mbgetmon.obj:  mbgetmon.cpp  $(DEPEND)
mbgetmor.obj:  mbgetmor.cpp  $(DEPEND)
mbgetpal.obj:  mbgetpal.cpp  $(DEPEND)
mbgetpas.obj:  mbgetpas.cpp  $(DEPEND)
mbgetpix.obj:  mbgetpix.cpp  $(DEPEND)
mbgettex.obj:  mbgettex.cpp  $(DEPEND)
mbgetvie.obj:  mbgetvie.cpp  $(DEPEND)
mbgetx.obj:    mbgetx.cpp    $(DEPEND)
mbgety.obj:    mbgety.cpp    $(DEPEND)
mbgraphd.obj:  mbgraphd.cpp  $(DEPEND)
mbgraphe.obj:  mbgraphe.cpp  $(DEPEND)
mbgraphf.obj:  mbgraphf.cpp  $(DEPEND)
mbgraphg.obj:  mbgraphg.cpp  $(DEPEND)
mbgraphr.obj:  mbgraphr.cpp  $(DEPEND)
mbimages.obj:  mbimages.cpp  $(DEPEND)
mbinitgr.obj:  mbinitgr.cpp  $(DEPEND)
mbinstld.obj:  mbinstld.cpp  $(DEPEND)
mbinstlf.obj:  mbinstlf.cpp  $(DEPEND)
mbline.obj:    mbline.cpp    $(DEPEND)
mblinere.obj:  mblinere.cpp  $(DEPEND)
mblineto.obj:  mblineto.cpp  $(DEPEND)
mbmovere.obj:  mbmovere.cpp  $(DEPEND)
mbmoveto.obj:  mbmoveto.cpp  $(DEPEND)
mbouttex.obj:  mbouttex.cpp  $(DEPEND)
mbouttxy.obj:  mbouttxy.cpp  $(DEPEND)
mbpiesli.obj:  mbpiesli.cpp  $(DEPEND)
mbputima.obj:  mbputima.cpp  $(DEPEND)
mbputpix.obj:  mbputpix.cpp  $(DEPEND)
mbrectan.obj:  mbrectan.cpp  $(DEPEND)
mbregisd.obj:  mbregisd.cpp  $(DEPEND)
mbregisf.obj:  mbregisf.cpp  $(DEPEND)
mbrestor.obj:  mbrestor.cpp  $(DEPEND)
mbsector.obj:  mbsector.cpp  $(DEPEND)
mbsetact.obj:  mbsetact.cpp  $(DEPEND)
mbsetall.obj:  mbsetall.cpp  $(DEPEND)
mbsetasp.obj:  mbsetasp.cpp  $(DEPEND)
mbsetbkc.obj:  mbsetbkc.cpp  $(DEPEND)
mbsetcol.obj:  mbsetcol.cpp  $(DEPEND)
mbsetflp.obj:  mbsetflp.cpp  $(DEPEND)
mbsetfls.obj:  mbsetfls.cpp  $(DEPEND)
mbsetgrb.obj:  mbsetgrb.cpp  $(DEPEND)
mbsetgrm.obj:  mbsetgrm.cpp  $(DEPEND)
mbsetlin.obj:  mbsetlin.cpp  $(DEPEND)
mbsetpal.obj:  mbsetpal.cpp  $(DEPEND)
mbsetrgb.obj:  mbsetrgb.cpp  $(DEPEND)
mbsettxj.obj:  mbsettxj.cpp  $(DEPEND)
mbsettxs.obj:  mbsettxs.cpp  $(DEPEND)
mbsetuse.obj:  mbsetuse.cpp  $(DEPEND)
mbsetvie.obj:  mbsetvie.cpp  $(DEPEND)
mbsetvis.obj:  mbsetvis.cpp  $(DEPEND)
mbsetwri.obj:  mbsetwri.cpp  $(DEPEND)
mbtexthe.obj:  mbtexthe.cpp  $(DEPEND)
mbtextwi.obj:  mbtextwi.cpp  $(DEPEND)
mballoc.obj:   mballoc.cpp   $(DEPEND)

# rules for compiling with Borland C/C++ V4
.cpp.obj:
!IF  $(IS386)
   bcc32 -WX -c $<  
!ELSE
   bcc -ml -c  $<  
!ENDIF

# /* End of File - MWBGIDOS.MAK */

